// File CutterDlg.h : header file
//

#if !defined(AFX_FILECUTTERDLG_H__04D3CC61_323F_11D4_AEAA_0060087165FF__INCLUDED_)
#define AFX_FILECUTTERDLG_H__04D3CC61_323F_11D4_AEAA_0060087165FF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CFileCutterDlg dialog

#include "DropEdit.h" //DropEdit Class
#include "Cut.h"	  //File Cutting Class
#include "Join.h"	  //File Joining Class
#include "Folder_dialog.h"
#include "defines.h"

class CFileCutterDlg : public CDialog
{
// Construction
public:
	
//	LRESULT OnClassSignal(WPARAM wParam, LPARAM lParam);
	CFileCutterDlg(CWnd* pParent = NULL);	// standard constructor

	class CCut  *pCut;
	class CJoin *pJoin;

// Dialog Data
	//{{AFX_DATA(CFileCutterDlg)
	enum { IDD = IDD_FILECUTTER_DIALOG };
	CProgressCtrl	m_progress;
	CComboBox	m_Size;
	CButton	m_Operation_Button;
	CString	m_Cut_File;
	CString	m_Join_Start_File;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFileCutterDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	CDropEdit m_dropEdit_Cut;
	CDropEdit m_dropEdit_JoinStart;

	int m_CuttingSizes[20];

	// Generated message map functions
	//{{AFX_MSG(CFileCutterDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonCutBrowse();
	afx_msg void OnButtonJoinStartBrowse();
	afx_msg void OnRadioCut();
	afx_msg void OnRadioJoin();
	afx_msg void OnOperationButton();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FILECUTTERDLG_H__04D3CC61_323F_11D4_AEAA_0060087165FF__INCLUDED_)
