// Join.cpp: implementation of the CJoin class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "File Cutter.h"
#include "File CutterDlg.h"
#include "Join.h"
#include "afx.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CJoin::CJoin()
{

}

CJoin::~CJoin()
{

}

void CJoin::FileJoinOperations(CString StartFile, CString JoinFolder)
{
	int x = StartFile.Find(".FC1");
	if( -1 == x)
	{
		AfxMessageBox("Invalid file format or Starting file was not selected.");
		return;
	}

	CFile infile;
	CFile outfile;
	CFileException e;
	
	short *buffer;
	int read;
	int BLOCK_SIZE;
	int stop = 0;	
	int nBytesWrote = 0;
	int counter = 0;
	BLOCK_SIZE = 2000;

	CString FileNamePath;
	int FileNamePathLength;
	CString FileTitle;
	int FileTitleLength;

	CString output_transfer_name;
	int size;
	CString data_type1;
	CString data_type2;
	CString data_type3;
	int size2;
	
	char FileNumber[100];
	char dataBuf[1000];
	char *pRecItems;
	pRecItems = dataBuf;

	if(infile.Open(StartFile, CFile::modeRead | CFile::typeBinary))
	{
		FileNamePath = infile.GetFilePath();
		FileNamePathLength = FileNamePath.GetLength();
		
		FileTitle = infile.GetFileTitle(); 
		FileTitleLength = FileTitle.GetLength();

		FileNamePath = FileNamePath.Left(FileNamePathLength - FileTitleLength);
		
		read = infile.Read(pRecItems, 1000);
		CString str(dataBuf);
		pRecItems[read] = 0;

		CString dataItem = pRecItems;

		int z = dataItem.Find("SIZE:");
		int y = dataItem.Find("FILENAME:");
		int x = dataItem.Find("FILES:");
		
		if( -1 != z)
			output_transfer_name = str.Mid(10, (z-11));
		
		if( -1 != z)
		{
			data_type1 = str.Mid((z+5),((y-1)-(z+5)));
			size = atoi(data_type1);
		}
		if( -1 != z)
		{
			data_type2 = str.Mid((y+9),((x-1)-(y+9)));
		}
		if( -1 != x)
		{
			data_type3 = dataItem.Right(read-(x+6));
			size2 = atoi(data_type3);
		}
	}
	else
	{
		if(e.m_cause == CFileException::fileNotFound)
			AfxMessageBox("File Not Found");
		else
			AfxMessageBox("Opening file failed");
		return;
	}

	infile.Close();

	buffer = (short*)malloc(BLOCK_SIZE * sizeof(short));
	if( buffer == NULL )
		AfxMessageBox("Insufficient memory available for file read buffer." );   
	
	output_transfer_name = JoinFolder + "\\" + output_transfer_name;
	
	if(!outfile.Open(output_transfer_name, CFile::modeWrite | CFile::modeCreate | CFile::typeBinary, &e))
	{
		AfxMessageBox("The output files were not created");
		return;
	}
	
	CString infiles;
	for(int i=1; i < (size2+1);i++)
	{
		sprintf(FileNumber, "%d", (i+1));
		
		infiles = FileNamePath + data_type2 + ".FC" + FileNumber;
		if(infile.Open(infiles, CFile::modeRead | CFile::typeBinary))
		{
			while(stop == 0)
			{
				read = infile.Read(buffer, sizeof(short) * BLOCK_SIZE);
				if (read == 0)
					break;

				outfile.Write(buffer, read);		
			}
		}
		else
		{
			if(e.m_cause == CFileException::fileNotFound)
				AfxMessageBox("File Not Found");
			else
				AfxMessageBox("Opening file failed");
			return;
		}
		infile.Close();
	}
	
	outfile.Close();
	free(buffer);
}